## oclgrind 18.3

=== CMakeLists.txt ===
# CMakeLists.txt (Oclgrind)
# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
# University of Bristol. All rights reserved.
#
# This program is provided under a three-clause BSD license. For full
# license terms please see the LICENSE file distributed with this
# source code.

cmake_minimum_required(VERSION 2.8.12)
project(Oclgrind)
set(Oclgrind_VERSION_MAJOR 18)
set(Oclgrind_VERSION_MINOR 3)

include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(TestBigEndian)

# Enable C99 for GCC (required for tests)
if (CMAKE_COMPILER_IS_GNUCC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
endif()

# Enable rpath on OS X
set(CMAKE_MACOSX_RPATH 1)

if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-aliasing")
endif()

# Disable min/max macros on Windows
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  add_definitions(-DNOMINMAX)
endif()

# Suppress warnings from OpenCL runtime API headers
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-ignored-attributes")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gcc-compat")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-availability")
endif()

# Detect endianness
test_big_endian(IS_BIG_ENDIAN)


# Find LLVM
find_package(LLVM REQUIRED CONFIG NO_CMAKE_BUILDS_PATH)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")
message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")

# Check LLVM version
if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.9")
  message(FATAL_ERROR "LLVM version must be >= 3.9")
endif()

# Warn about LLVM 4.0 InstCombine/addrspacecast bug
if ("${LLVM_VERSION_MAJOR}" STREQUAL "4" AND
    "${LLVM_VERSION_PATCH}" STREQUAL "0")
   message(WARNING
   "There is a known bug with LLVM 4.0.0 that will cause "
   "Oclgrind to fail on some kernels with a message about "
   "`addrspacecast`. Use LLVM 3.9 or 4.0.1+ if possible.")
endif()

# Add flags for LLVM
add_definitions(${LLVM_DEFINITIONS})
include_directories(${LLVM_INCLUDE_DIRS})
link_directories(${LLVM_LIBRARY_DIRS})

# Get LLVM libraries for linking
llvm_map_components_to_libnames(LLVM_LIBS
  bitreader bitwriter core coverage instrumentation ipo irreader
  linker lto mcparser objcarcopts option target)

if (NOT (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0"))
  llvm_map_components_to_libnames(LLVM_COROUTINES coroutines)
  list(APPEND LLVM_LIBS ${LLVM_COROUTINES})
endif()


# Allow user to set path to Clang installation via CLANG_ROOT
set (CLANG_ROOT " " CACHE PATH "Root of Clang installation")
if (NOT ${CLANG_ROOT} STREQUAL " ")
  include_directories("${CLANG_ROOT}/include")
  link_directories("${CLANG_ROOT}/lib")
  set(CMAKE_REQUIRED_INCLUDES
      "${CMAKE_REQUIRED_INCLUDES};${CLANG_ROOT}/include")
endif()

set(CMAKE_REQUIRED_INCLUDES
    "${CMAKE_REQUIRED_INCLUDES};${LLVM_INCLUDE_DIRS}")
set(CMAKE_REQUIRED_DEFINITIONS
    "${CMAKE_REQUIRED_DEFINITIONS};${LLVM_DEFINITIONS}")

# Check for Clang headers
unset(CLANG_HEADER CACHE)
find_path(CLANG_HEADER "clang/CodeGen/CodeGenAction.h"
          PATHS "${CLANG_ROOT}/include" "${LLVM_INCLUDE_DIRS}"
          NO_DEFAULT_PATH)
find_path(CLANG_HEADER "clang/CodeGen/CodeGenAction.h")
if ("${CLANG_HEADER}" STREQUAL "CLANG_HEADER-NOTFOUND")
  message(FATAL_ERROR "Clang headers not found (set CLANG_ROOT)")
endif()

# Check for Clang libraries
unset(CLANG_LIB CACHE)
find_library(CLANG_LIB "clangFrontend"
             PATHS "${CLANG_ROOT}/lib" "${LLVM_LIBRARY_DIRS}"
             NO_DEFAULT_PATH)
find_library(CLANG_LIB "clangFrontend")
if ("${CLANG_LIB}" STREQUAL "CLANG_LIB-NOTFOUND")
  message(FATAL_ERROR "Clang libraries not found (set CLANG_ROOT)")
endif()

# Get path to Clang's opencl-c.h header
get_filename_component(CLANG_LIB_DIR "${CLANG_LIB}" DIRECTORY)
set(CLANG_FULL_VERSION
    "${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH}")
set(CLANG_OPENCL_C_H
    "${CLANG_LIB_DIR}/clang/${CLANG_FULL_VERSION}/include/opencl-c.h")
if (NOT EXISTS "${CLANG_OPENCL_C_H}")
  message(FATAL_ERROR "\nClang opencl-c.h not found:\n\t${CLANG_OPENCL_C_H}")
else()
  message(STATUS "Using opencl-c.h: ${CLANG_OPENCL_C_H}")
endif()

# Check for clang
find_program(CLANG clang
             PATHS "${CLANG_ROOT}/bin" "${LLVM_TOOLS_BINARY_DIR}"
             NO_DEFAULT_PATH)
find_program(CLANG clang)
if ("${CLANG}" STREQUAL "CLANG-NOTFOUND")
  message(FATAL_ERROR "Could not find clang binary")
endif()


# Check for GNU readline library
if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  set(READLINE_DIR "" CACHE PATH "Location of GNU readline library")

  set(CMAKE_REQUIRED_INCLUDES ${READLINE_DIR}/include)
  include_directories(${READLINE_DIR}/include)
  link_directories(${READLINE_DIR}/lib)

  check_include_files("stdio.h;readline/readline.h" HAVE_READLINE_H)
  check_include_files("stdio.h;readline/history.h" HAVE_HISTORY_H)
  check_library_exists(readline readline
                       "${READLINE_DIR}/lib" HAVE_READLINE_LIB)
  check_library_exists(readline add_history
                       "${READLINE_DIR}/lib" HAVE_HISTORY_LIB)
  if (HAVE_READLINE_H AND HAVE_HISTORY_H AND
      HAVE_READLINE_LIB AND HAVE_HISTORY_LIB)
    set(HAVE_READLINE 1)
    list(APPEND CORE_EXTRA_LIBS readline)
  else()
    set(HAVE_READLINE 0)
    message(WARNING "GNU readline library not found (set READLINE_DIR)\n"
                    "The interactive debugger will not have a command history.")
  endif()
else()
 set(HAVE_READLINE 0)
endif()

# Check for library directory suffixes
set(_LIBDIR_SUFFIX "")
get_property(USING_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USING_LIB64 AND NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
  set(_LIBDIR_SUFFIX "64")
endif()
set(LIBDIR_SUFFIX "${_LIBDIR_SUFFIX}"
    CACHE STRING "Suffix for installed library directory")

# Generate stringified opencl-c.h
add_custom_command(
  OUTPUT src/core/opencl-c.h.cpp
  COMMAND ${CMAKE_COMMAND} -DSOURCE_FILE=${CLANG_OPENCL_C_H}
    -P ${CMAKE_SOURCE_DIR}/src/core/gen_opencl-c.h.cmake
  DEPENDS ${CLANG_OPENCL_C_H} src/core/gen_opencl-c.h.cmake
)

include_directories("src/" "${PROJECT_BINARY_DIR}")

if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  set(CORE_LIB_TYPE "SHARED")
endif()

set(CORE_HEADERS
  src/core/common.h
  src/core/Context.h
  src/core/half.h
  src/core/Kernel.h
  src/core/KernelInvocation.h
  src/core/Memory.h
  src/core/Plugin.h
  src/core/Program.h
  src/core/Queue.h
  src/core/WorkItem.h
  src/core/WorkGroup.h)

add_library(oclgrind ${CORE_LIB_TYPE}
  ${CORE_HEADERS}
  src/core/opencl-c.h.cpp
  src/core/common.cpp
  src/core/Context.cpp
  src/core/half.cpp
  src/core/Kernel.cpp
  src/core/KernelInvocation.cpp
  src/core/Memory.cpp
  src/core/Plugin.cpp
  src/core/Program.cpp
  src/core/Queue.cpp
  src/core/WorkItem.cpp
  src/core/WorkItemBuiltins.cpp
  src/core/WorkGroup.cpp
  src/plugins/InstructionCounter.h
  src/plugins/InstructionCounter.cpp
  src/plugins/InteractiveDebugger.h
  src/plugins/InteractiveDebugger.cpp
  src/plugins/Logger.h
  src/plugins/Logger.cpp
  src/plugins/MemCheck.h
  src/plugins/MemCheck.cpp
  src/plugins/RaceDetector.h
  src/plugins/RaceDetector.cpp
  src/plugins/Uninitialized.h
  src/plugins/Uninitialized.cpp)
target_link_libraries(oclgrind PRIVATE ${CORE_EXTRA_LIBS}
  clangFrontend clangSerialization clangDriver clangCodeGen
  clangParse clangSema clangAnalysis clangEdit clangAST clangLex clangBasic
  ${LLVM_LIBS})

if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  target_link_libraries(oclgrind PRIVATE Version)
endif()

# Sources for OpenCL runtime API frontend
set(RUNTIME_SOURCES
  src/runtime/async_queue.h
  src/runtime/async_queue.cpp
  src/runtime/icd.h
  src/runtime/runtime.cpp)

# Add ICD exports on Windows
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  set(DLL_EXPORTS src/runtime/icd.def)
endif()

add_library(oclgrind-rt-icd SHARED ${RUNTIME_SOURCES} ${DLL_EXPORTS})
set_target_properties(oclgrind-rt-icd PROPERTIES COMPILE_FLAGS -DOCLGRIND_ICD)
target_link_libraries(oclgrind-rt-icd ${CMAKE_DL_LIBS} oclgrind)

# Add runtime exports on Windows
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  set(DLL_EXPORTS src/runtime/runtime.def)
endif()

add_library(oclgrind-rt SHARED ${RUNTIME_SOURCES} ${DLL_EXPORTS})
target_link_libraries(oclgrind-rt ${CMAKE_DL_LIBS} oclgrind)

if (UNIX AND NOT APPLE)
  # Change the SONAME of the library so that it gets recognized by dlopen
  set_target_properties(oclgrind-rt PROPERTIES
                        NO_SONAME ON
                        LINK_FLAGS "-Wl,-soname,libOpenCL.so")
endif()

add_executable(oclgrind-exe src/runtime/oclgrind.cpp)
set_target_properties(oclgrind-exe PROPERTIES OUTPUT_NAME oclgrind)
target_compile_definitions(oclgrind-exe PRIVATE
                           "-DLIBDIR_SUFFIX=\"${LIBDIR_SUFFIX}\"")

add_executable(oclgrind-kernel
  src/kernel/oclgrind-kernel.cpp
  src/kernel/Simulation.h
  src/kernel/Simulation.cpp)
target_link_libraries(oclgrind-kernel oclgrind)

set(OPENCL_C_H
 ${CMAKE_BINARY_DIR}/include/oclgrind/opencl-c.h
 ${CMAKE_BINARY_DIR}/include/oclgrind/opencl-c-1.2-32.pch
 ${CMAKE_BINARY_DIR}/include/oclgrind/opencl-c-1.2-64.pch
 ${CMAKE_BINARY_DIR}/include/oclgrind/opencl-c-2.0-32.pch
 ${CMAKE_BINARY_DIR}/include/oclgrind/opencl-c-2.0-64.pch
)

add_custom_target(OPENCL_C_HEADERS ALL DEPENDS ${OPENCL_C_H})

add_custom_command(
  OUTPUT include/oclgrind/opencl-c.h
  POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E
    copy ${CLANG_OPENCL_C_H} include/oclgrind/opencl-c.h
  DEPENDS ${CLANG_OPENCL_C_H})

# Generate precompiled headers for opencl-c.h
set(OPENCL_C_H_SYSROOT "${CMAKE_BINARY_DIR}/include/oclgrind/")
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  string(REPLACE "/" "\\" OPENCL_C_H_SYSROOT "${OPENCL_C_H_SYSROOT}")
endif()
add_custom_command(
  OUTPUT include/oclgrind/opencl-c-1.2-32.pch
  POST_BUILD
  COMMAND
    ${CLANG}
    -cc1 -x cl -cl-std=CL1.2 -O0 -fno-builtin -fgnu89-inline
    -emit-pch -triple spir-unknown-unknown
    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
    include/oclgrind/opencl-c.h
    -o include/oclgrind/opencl-c-1.2-32.pch
  DEPENDS include/oclgrind/opencl-c.h
)
add_custom_command(
  OUTPUT include/oclgrind/opencl-c-1.2-64.pch
  POST_BUILD
  COMMAND
    ${CLANG}
    -cc1 -x cl -cl-std=CL1.2 -O0 -fno-builtin -fgnu89-inline
    -emit-pch -triple spir64-unknown-unknown
    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
    include/oclgrind/opencl-c.h
    -o include/oclgrind/opencl-c-1.2-64.pch
  DEPENDS include/oclgrind/opencl-c.h
)
add_custom_command(
  OUTPUT include/oclgrind/opencl-c-2.0-32.pch
  POST_BUILD
  COMMAND
    ${CLANG}
    -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
    -emit-pch -triple spir-unknown-unknown
    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
    include/oclgrind/opencl-c.h
    -o include/oclgrind/opencl-c-2.0-32.pch
  DEPENDS include/oclgrind/opencl-c.h
)
add_custom_command(
  OUTPUT include/oclgrind/opencl-c-2.0-64.pch
  POST_BUILD
  COMMAND
    ${CLANG}
    -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
    -emit-pch -triple spir64-unknown-unknown
    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
    include/oclgrind/opencl-c.h
    -o include/oclgrind/opencl-c-2.0-64.pch
  DEPENDS include/oclgrind/opencl-c.h
)


# Generate config.h
set(LLVM_VERSION ${LLVM_VERSION_MAJOR}${LLVM_VERSION_MINOR})
configure_file("config.h.in" "config.h")


# Generate ICD loader if not on Windows
if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
  file(GENERATE OUTPUT ${CMAKE_BINARY_DIR}/oclgrind.icd
       CONTENT "${CMAKE_INSTALL_PREFIX}/lib${LIBDIR_SUFFIX}/$<TARGET_FILE_NAME:oclgrind-rt-icd>\n")
endif()

install(TARGETS
  oclgrind-exe oclgrind-kernel
  DESTINATION bin)
install(TARGETS
  oclgrind oclgrind-rt oclgrind-rt-icd
  DESTINATION "lib${LIBDIR_SUFFIX}")
install(FILES

=== tests/apps/CMakeLists.txt ===
# CMakeLists.txt (Oclgrind)
# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
# University of Bristol. All rights reserved.
#
# This program is provided under a three-clause BSD license. For full
# license terms please see the LICENSE file distributed with this
# source code.

set(COMMON_SOURCES ../common/common.c ../common/common.h)
include_directories(../common)

# Add app tests
foreach(test
  image
  vecadd)

  add_executable(${test} ${test}/${test}.c ${COMMON_SOURCES})
  target_link_libraries(${test} oclgrind-rt)

  # Generate test binaries in same dir as Oclgrind libraries on Windows
  if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
    set_target_properties(${test} PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
  else()
    set_target_properties(${test} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${test}")
    set_target_properties(${test} PROPERTIES LINKER_LANGUAGE CXX)
  endif()

  add_test(
    NAME app_${test}
    COMMAND
    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/run_test.py
    $<TARGET_FILE:oclgrind-exe>
    $<TARGET_FILE:${test}>)

  set_tests_properties(app_${test} PROPERTIES DEPENDS ${test})

  # Set PCH directory
  set(ENV "OCLGRIND_TESTING=1")
  list(APPEND ENV "OCLGRIND_PCH_DIR=${CMAKE_BINARY_DIR}/include/oclgrind")
  set_tests_properties(app_${test} PROPERTIES ENVIRONMENT "${ENV}")

endforeach(${test})

=== tests/kernels/CMakeLists.txt ===
# CMakeLists.txt (Oclgrind)
# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
# University of Bristol. All rights reserved.
#
# This program is provided under a three-clause BSD license. For full
# license terms please see the LICENSE file distributed with this
# source code.

# Add kernel tests
file(READ TESTS KERNEL_TESTS)
string(REPLACE "\n" ";" KERNEL_TESTS ${KERNEL_TESTS})
foreach(test ${KERNEL_TESTS})
  add_test(
    NAME ${test}
    COMMAND
    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/run_test.py
    $<TARGET_FILE:oclgrind-kernel>
    ${CMAKE_SOURCE_DIR}/tests/kernels/${test}.sim)
endforeach(${test})

# Set PCH directory
set_tests_properties(${KERNEL_TESTS} PROPERTIES
    ENVIRONMENT "OCLGRIND_PCH_DIR=${CMAKE_BINARY_DIR}/include/oclgrind")

# LLVM bug, exposed in 4.0, fixed in 5.0, backported to 4.0.1
if ("${LLVM_VERSION_MAJOR}" STREQUAL "4" AND
    "${LLVM_VERSION_PATCH}" STREQUAL "0")
  set(XFAIL
      ${XFAIL}
      bugs/byval_function_argument
      bugs/const_gep_expr_pointee_type
      bugs/multidim_array_in_struct
      memcheck/static_array_padded_struct
      misc/array
      uninitialized/private_array_initializer_list
  )
endif()

# Can't seem to get DIGlobalVariable in LLVM 3.9
if ("${LLVM_VERSION_MAJOR}" STRLESS "4")
  set(XFAIL ${XFAIL} interactive/struct_member)
endif()

# LLVM bug, exposed in 4.0, fixed in 5.0, backported to 4.0.1
if ("${LLVM_VERSION_MAJOR}" STREQUAL "4" AND
    "${LLVM_VERSION_PATCH}" STREQUAL "0")
  set(XFAIL ${XFAIL} bugs/llvm_memcpyopt_bug)
endif()

# Expected failures
set_tests_properties(${XFAIL} PROPERTIES WILL_FAIL TRUE)

=== tests/runtime/CMakeLists.txt ===
# CMakeLists.txt (Oclgrind)
# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
# University of Bristol. All rights reserved.
#
# This program is provided under a three-clause BSD license. For full
# license terms please see the LICENSE file distributed with this
# source code.

set(COMMON_SOURCES ../common/common.c ../common/common.h)
include_directories(../common)

# Add runtime tests
foreach(test
  build_program
  map_buffer
  sampler)

  add_executable(${test} ${test}.c ${COMMON_SOURCES})
  target_compile_definitions(${test} PRIVATE
                             "-DROOT_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"")
  target_link_libraries(${test} oclgrind-rt)

  # Generate test binaries in same dir as Oclgrind libraries on Windows
  if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
    set_target_properties(${test} PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}")
  else()
    set_target_properties(${test} PROPERTIES LINKER_LANGUAGE CXX)
  endif()

  add_test(
    NAME rt_${test}
    COMMAND
    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/run_test.py
    $<TARGET_FILE:oclgrind-exe>
    $<TARGET_FILE:${test}>)

  set_tests_properties(rt_${test} PROPERTIES DEPENDS ${test})

  # Set PCH directory
  set(ENV "OCLGRIND_TESTING=1")
  list(APPEND ENV "OCLGRIND_PCH_DIR=${CMAKE_BINARY_DIR}/include/oclgrind")
  set_tests_properties(rt_${test} PROPERTIES ENVIRONMENT "${ENV}")

endforeach(${test})

=== debian/changelog ===
oclgrind (18.3-2) unstable; urgency=medium

  * Switch to LLVM/Clang 7.  (Closes: #912796)
  * Cherry-pick upstream patch for linking with Clang 7.
  * Drop versioned constraints that are satisfied in jessie.
  * Switch to debhelper-compat (= 12).
  * Bump Standards-Version to 4.1.3. No changes needed.
  * Add myself to Uploaders.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 03 Feb 2019 14:27:59 +0100

oclgrind (18.3-1) unstable; urgency=low

  [ James Price ]
  * New upstream release
  * Refresh patches, drop those applied upstream
  * Update to LLVM/Clang 6.0 (Closes: #873422)
  * Bump Standards-Version to 4.1.3
  * Add debian/upstream/metadata file

  [ Andreas Beckmann ]
  * Switch Vcs-* URLs to salsa.debian.org.
  * Install NEWS as upstream changelog.

 -- James Price <j.price@bristol.ac.uk>  Sun, 11 Mar 2018 09:31:39 +0000

=== debian/control ===
Source: oclgrind
Section: devel
Priority: optional
Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 James Price <j.price@bristol.ac.uk>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 12),
 dh-exec,
 cmake,
 llvm-7-dev,
 libclang-7-dev,
 clang-7,
 libedit-dev,
 zlib1g-dev,
 libreadline-dev,
 opencl-c-headers,
 python,
Standards-Version: 4.3.0
Homepage: https://github.com/jrprice/Oclgrind
Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git

Package: liboclgrind-18.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: core library for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the core library for Oclgrind, implementing the
 simulator, plugin interface, and providing several built-in plugins.

Package: liboclgrind-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, liboclgrind-18.3 (= ${binary:Version})
Description: development files for Oclgrind
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 This package provides the development headers and libraries used for
 creating new Oclgrind plugins.

Package: oclgrind
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-18.3
Description: OpenCL device simulator
 Oclgrind is an extensible OpenCL device simulator that provides a
 plugin interface to facilitate the creation of tools to aid analysis
 and development of OpenCL programs. Among the tools that Oclgrind
 provides are various debugging aids, such as out-of-bounds memory
 access checking, data-race detection, and an interactive debugger.
 .
 Oclgrind implements the OpenCL 1.2 runtime API, which makes
 simulating an existing OpenCL program very straightforward - simply
 prefix your usual application command-line with 'oclgrind'. There is
 also a simple interface for simulating individual kernels in
 isolation via the 'oclgrind-kernel' command.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if [ -d src/CL ]; then mv src/CL src/CL-Do-Not-Use ; fi
	dh_auto_configure -- -DLLVM_DIR=/usr/lib/llvm-7/lib/cmake/llvm

override_dh_auto_clean:
	dh_auto_clean
	find tests/ -name "*.out" -delete
	if [ -d src/CL-Do-Not-Use ]; then mv src/CL-Do-Not-Use src/CL ; fi

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -Xliboclgrind-rt

=== debian/watch ===
version=3

https://github.com/jrprice/Oclgrind/releases /jrprice/Oclgrind/archive/v(.*)\.tar\.gz

## oclgrind 19.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # CMakeLists.txt (Oclgrind)
-# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
+# Copyright (c) 2013-2019, James Price and Simon McIntosh-Smith,
 # University of Bristol. All rights reserved.
 #
 # This program is provided under a three-clause BSD license. For full
@@ -8,8 +8,8 @@
 
 cmake_minimum_required(VERSION 2.8.12)
 project(Oclgrind)
-set(Oclgrind_VERSION_MAJOR 18)
-set(Oclgrind_VERSION_MINOR 3)
+set(Oclgrind_VERSION_MAJOR 19)
+set(Oclgrind_VERSION_MINOR 10)
 
 include(CheckIncludeFiles)
 include(CheckIncludeFileCXX)
@@ -53,17 +53,8 @@
 message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
 
 # Check LLVM version
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "3.9")
-  message(FATAL_ERROR "LLVM version must be >= 3.9")
-endif()
-
-# Warn about LLVM 4.0 InstCombine/addrspacecast bug
-if ("${LLVM_VERSION_MAJOR}" STREQUAL "4" AND
-    "${LLVM_VERSION_PATCH}" STREQUAL "0")
-   message(WARNING
-   "There is a known bug with LLVM 4.0.0 that will cause "
-   "Oclgrind to fail on some kernels with a message about "
-   "`addrspacecast`. Use LLVM 3.9 or 4.0.1+ if possible.")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "5.0")
+  message(FATAL_ERROR "LLVM version must be >= 5.0")
 endif()
 
 # Add flags for LLVM
@@ -73,14 +64,8 @@
 
 # Get LLVM libraries for linking
 llvm_map_components_to_libnames(LLVM_LIBS
-  bitreader bitwriter core coverage instrumentation ipo irreader
+  bitreader bitwriter core coroutines coverage instrumentation ipo irreader
   linker lto mcparser objcarcopts option target)
-
-if (NOT (${LLVM_PACKAGE_VERSION} VERSION_LESS "4.0"))
-  llvm_map_components_to_libnames(LLVM_COROUTINES coroutines)
-  list(APPEND LLVM_LIBS ${LLVM_COROUTINES})
-endif()
-
 
 # Allow user to set path to Clang installation via CLANG_ROOT
 set (CLANG_ROOT " " CACHE PATH "Root of Clang installation")
@@ -229,8 +214,9 @@
   src/plugins/Uninitialized.h
   src/plugins/Uninitialized.cpp)
 target_link_libraries(oclgrind PRIVATE ${CORE_EXTRA_LIBS}
-  clangFrontend clangSerialization clangDriver clangCodeGen
-  clangParse clangSema clangAnalysis clangEdit clangAST clangLex clangBasic
+  clangCodeGen clangFrontend clangSerialization clangDriver
+  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
+  clangLex clangBasic
   ${LLVM_LIBS})
 
 if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
@@ -369,3 +355,28 @@
   oclgrind oclgrind-rt oclgrind-rt-icd
   DESTINATION "lib${LIBDIR_SUFFIX}")
 install(FILES
+  ${CORE_HEADERS} ${OPENCL_C_H}
+  DESTINATION include/oclgrind)
+if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
+  install(FILES
+    src/CL/cl.h
+    src/CL/cl_d3d10.h
+    src/CL/cl_d3d11.h
+    src/CL/cl_dx9_media_sharing.h
+    src/CL/cl_egl.h
+    src/CL/cl_ext.h
+    src/CL/cl_gl.h
+    src/CL/cl_gl_ext.h
+    src/CL/cl_platform.h
+    src/CL/opencl.h
+    DESTINATION include/CL)
+endif()
+
+
+# Tests
+enable_testing()
+
+# Check for Python
+find_package(PythonInterp)
+if (PYTHONINTERP_FOUND)
+

=== tests/apps/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # CMakeLists.txt (Oclgrind)
-# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
+# Copyright (c) 2013-2019, James Price and Simon McIntosh-Smith,
 # University of Bristol. All rights reserved.
 #
 # This program is provided under a three-clause BSD license. For full

=== tests/runtime/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # CMakeLists.txt (Oclgrind)
-# Copyright (c) 2013-2016, James Price and Simon McIntosh-Smith,
+# Copyright (c) 2013-2019, James Price and Simon McIntosh-Smith,
 # University of Bristol. All rights reserved.
 #
 # This program is provided under a three-clause BSD license. For full
@@ -12,7 +12,9 @@
 # Add runtime tests
 foreach(test
   build_program
+  kernel_scope_local_mem_usage
   map_buffer
+  multqueues
   sampler)
 
   add_executable(${test} ${test}.c ${COMMON_SOURCES})

=== debian/changelog ===
oclgrind (19.10-4) unstable; urgency=medium

  * Add dependency on libclang-common-9-dev.  (Closes: #971572)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Jun 2021 16:20:02 +0200

oclgrind (19.10-3) unstable; urgency=medium

  * Fix liboclgrind.so symlink.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Mar 2021 12:16:58 +0100

oclgrind (19.10-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Build with llvm-9 (Closes: #968496)

  [ Andreas Beckmann ]
  * Switch to debhelper-compat (= 13).
  * Bump Standards-Version to 4.5.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Aug 2020 15:29:42 +0200

oclgrind (19.10-1) unstable; urgency=medium

  [ James Price ]
  * New upstream release
  * Refresh patches, drop those applied upstream
  * Bump Standards-Version to 4.4.1. No changes needed.
  * Switch to LLVM/Clang 8
  * Use Python 3 (Closes: #943197)

  [ Andreas Beckmann ]
  * Set Rules-Requires-Root: no.

 -- James Price <jamesprice.dev@gmail.com>  Mon, 25 Nov 2019 01:04:06 +0000

oclgrind (18.3-3) unstable; urgency=medium

  * Link against libatomic if needed.
  * Ship liboclgrind-rt-icd.so.
  * Bump Standards-Version to 4.4.0. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 31 Jul 2019 19:42:30 +0200

=== debian/control ===
--- 
+++ 
@@ -3,30 +3,31 @@
 Priority: optional
 Maintainer: Debian OpenCL Maintainers <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders:
- James Price <j.price@bristol.ac.uk>,
+ James Price <jamesprice.dev@gmail.com>,
  Andreas Beckmann <anbe@debian.org>,
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-exec,
  cmake,
- llvm-7-dev,
- libclang-7-dev,
- clang-7,
+ llvm-9-dev,
+ libclang-9-dev,
+ clang-9,
  libedit-dev,
  zlib1g-dev,
  libreadline-dev,
  opencl-c-headers,
- python,
-Standards-Version: 4.3.0
+ python3,
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://github.com/jrprice/Oclgrind
 Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
 Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git
 
-Package: liboclgrind-18.3
+Package: liboclgrind-19.10
 Architecture: any
 Multi-Arch: same
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, libclang-common-${llvm:Version}-dev, ${misc:Depends}
 Description: core library for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -41,7 +42,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, liboclgrind-18.3 (= ${binary:Version})
+Depends: ${misc:Depends}, liboclgrind-19.10 (= ${binary:Version})
 Description: development files for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -55,7 +56,7 @@
 Package: oclgrind
 Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-18.3
+Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-19.10
 Description: OpenCL device simulator
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS  = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	if [ -d src/CL ]; then mv src/CL src/CL-Do-Not-Use ; fi
	dh_auto_configure -- -DLLVM_DIR=/usr/lib/llvm-$(LLVM_VERSION)/lib/cmake/llvm

execute_after_dh_auto_clean:
	find tests/ -name "*.out" -delete
	if [ -d src/CL-Do-Not-Use ]; then mv src/CL-Do-Not-Use src/CL ; fi

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_makeshlibs:
	dh_makeshlibs -Xliboclgrind-rt

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'llvm:Version=$(LLVM_VERSION)'

## oclgrind 21.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 # license terms please see the LICENSE file distributed with this
 # source code.
 
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.1)
 project(Oclgrind)
-set(Oclgrind_VERSION_MAJOR 19)
+set(Oclgrind_VERSION_MAJOR 21)
 set(Oclgrind_VERSION_MINOR 10)
 
 include(CheckIncludeFiles)
@@ -21,11 +21,20 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
 endif()
 
+# Require C++14 (hard requirement for LLVM >10)
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
 # Enable rpath on OS X
 set(CMAKE_MACOSX_RPATH 1)
 
+# Enable WIP 3.0 support.
+option(ENABLE_EXPERIMENTAL_OPENCL_3, "Enable experimental OpenCL 3.0 support.")
+if (${ENABLE_EXPERIMENTAL_OPENCL_3})
+  add_definitions(-DENABLE_OPENCL_3)
+endif()
+
 if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-strict-aliasing")
@@ -53,8 +62,8 @@
 message(STATUS "Using LLVMConfig.cmake in: ${LLVM_DIR}")
 
 # Check LLVM version
-if (${LLVM_PACKAGE_VERSION} VERSION_LESS "5.0")
-  message(FATAL_ERROR "LLVM version must be >= 5.0")
+if (${LLVM_PACKAGE_VERSION} VERSION_LESS "11.0")
+  message(FATAL_ERROR "LLVM version must be >= 11.0")
 endif()
 
 # Add flags for LLVM
@@ -63,9 +72,20 @@
 link_directories(${LLVM_LIBRARY_DIRS})
 
 # Get LLVM libraries for linking
-llvm_map_components_to_libnames(LLVM_LIBS
-  bitreader bitwriter core coroutines coverage instrumentation ipo irreader
-  linker lto mcparser objcarcopts option target)
+list(FIND LLVM_AVAILABLE_LIBS LLVM _LLVM_SHARED_INDEX)
+if (${_LLVM_SHARED_INDEX} GREATER -1)
+  set(LLVM_LIBS LLVM)
+else()
+  llvm_map_components_to_libnames(LLVM_LIBS
+    bitreader bitwriter core coroutines coverage frontendopenmp instrumentation
+    ipo irreader linker lto mcparser objcarcopts option target)
+endif()
+
+# https://bugs.llvm.org/show_bug.cgi?id=44870
+list(FIND LLVM_AVAILABLE_LIBS Polly _POLLY_INDEX)
+if (${_POLLY_INDEX} GREATER -1)
+  list(APPEND LLVM_LIBS Polly)
+endif()
 
 # Allow user to set path to Clang installation via CLANG_ROOT
 set (CLANG_ROOT " " CACHE PATH "Root of Clang installation")
@@ -97,8 +117,22 @@
              PATHS "${CLANG_ROOT}/lib" "${LLVM_LIBRARY_DIRS}"
              NO_DEFAULT_PATH)
 find_library(CLANG_LIB "clangFrontend")
+set(CLANG_LIBS
+  clangCodeGen clangFrontend clangSerialization clangDriver
+  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
+  clangLex clangBasic)
+
 if ("${CLANG_LIB}" STREQUAL "CLANG_LIB-NOTFOUND")
-  message(FATAL_ERROR "Clang libraries not found (set CLANG_ROOT)")
+  # https://releases.llvm.org/10.0.0/tools/clang/docs/ReleaseNotes.html#build-system-changes
+  find_library(CLANG_LIB "clang-cpp"
+               PATHS "${CLANG_ROOT}/lib" "${LLVM_LIBRARY_DIRS}"
+               NO_DEFAULT_PATH)
+  find_library(CLANG_LIB "clang-cpp")
+  set(CLANG_LIBS "clang-cpp")
+
+  if ("${CLANG_LIB}" STREQUAL "CLANG_LIB-NOTFOUND")
+    message(FATAL_ERROR "Clang libraries not found (set CLANG_ROOT)")
+  endif()
 endif()
 
 # Get path to Clang's opencl-c.h header
@@ -111,6 +145,10 @@
   message(FATAL_ERROR "\nClang opencl-c.h not found:\n\t${CLANG_OPENCL_C_H}")
 else()
   message(STATUS "Using opencl-c.h: ${CLANG_OPENCL_C_H}")
+endif()
+
+if (EXISTS "${CLANG_LIB_DIR}/clang/${CLANG_FULL_VERSION}/include/opencl-c-base.h")
+  set(CLANG_OPENCL_C_BASE_H "${CLANG_LIB_DIR}/clang/${CLANG_FULL_VERSION}/include/opencl-c-base.h")
 endif()
 
 # Check for clang
@@ -176,7 +214,6 @@
 set(CORE_HEADERS
   src/core/common.h
   src/core/Context.h
-  src/core/half.h
   src/core/Kernel.h
   src/core/KernelInvocation.h
   src/core/Memory.h
@@ -191,7 +228,6 @@
   src/core/opencl-c.h.cpp
   src/core/common.cpp
   src/core/Context.cpp
-  src/core/half.cpp
   src/core/Kernel.cpp
   src/core/KernelInvocation.cpp
   src/core/Memory.cpp
@@ -213,11 +249,9 @@
   src/plugins/RaceDetector.cpp
   src/plugins/Uninitialized.h
   src/plugins/Uninitialized.cpp)
-target_link_libraries(oclgrind PRIVATE ${CORE_EXTRA_LIBS}
-  clangCodeGen clangFrontend clangSerialization clangDriver
-  clangParse clangSema clangAnalysis clangEdit clangAST clangASTMatchers
-  clangLex clangBasic
-  ${LLVM_LIBS})
+target_link_libraries(oclgrind
+  PRIVATE ${CORE_EXTRA_LIBS} ${CLANG_LIBS}
+  PUBLIC ${LLVM_LIBS})
 
 if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
   target_link_libraries(oclgrind PRIVATE Version)
@@ -275,12 +309,23 @@
 
 add_custom_target(OPENCL_C_HEADERS ALL DEPENDS ${OPENCL_C_H})
 
+if (CLANG_OPENCL_C_BASE_H)
+  add_custom_command(
+    OUTPUT include/oclgrind/opencl-c-base.h
+    POST_BUILD
+    COMMAND ${CMAKE_COMMAND} -E
+      copy ${CLANG_OPENCL_C_BASE_H} include/oclgrind/opencl-c-base.h
+    DEPENDS ${CLANG_OPENCL_C_BASE_H})
+  set(OPENCL_C_H_DEPENDS include/oclgrind/opencl-c-base.h)
+  set(OPENCL_C_H ${OPENCL_C_H} ${CMAKE_BINARY_DIR}/${OPENCL_C_H_DEPENDS})
+endif()
+
 add_custom_command(
   OUTPUT include/oclgrind/opencl-c.h
   POST_BUILD
   COMMAND ${CMAKE_COMMAND} -E
     copy ${CLANG_OPENCL_C_H} include/oclgrind/opencl-c.h
-  DEPENDS ${CLANG_OPENCL_C_H})
+  DEPENDS ${CLANG_OPENCL_C_H} ${OPENCL_C_H_DEPENDS})
 
 # Generate precompiled headers for opencl-c.h
 set(OPENCL_C_H_SYSROOT "${CMAKE_BINARY_DIR}/include/oclgrind/")
@@ -319,64 +364,3 @@
     -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
     -emit-pch -triple spir-unknown-unknown
     -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
-    include/oclgrind/opencl-c.h
-    -o include/oclgrind/opencl-c-2.0-32.pch
-  DEPENDS include/oclgrind/opencl-c.h
-)
-add_custom_command(
-  OUTPUT include/oclgrind/opencl-c-2.0-64.pch
-  POST_BUILD
-  COMMAND
-    ${CLANG}
-    -cc1 -x cl -cl-std=CL2.0 -O0 -fno-builtin -fgnu89-inline
-    -emit-pch -triple spir64-unknown-unknown
-    -relocatable-pch -isysroot "${OPENCL_C_H_SYSROOT}"
-    include/oclgrind/opencl-c.h
-    -o include/oclgrind/opencl-c-2.0-64.pch
-  DEPENDS include/oclgrind/opencl-c.h
-)
-
-
-# Generate config.h
-set(LLVM_VERSION ${LLVM_VERSION_MAJOR}${LLVM_VERSION_MINOR})
-configure_file("config.h.in" "config.h")
-
-
-# Generate ICD loader if not on Windows
-if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  file(GENERATE OUTPUT ${CMAKE_BINARY_DIR}/oclgrind.icd
-       CONTENT "${CMAKE_INSTALL_PREFIX}/lib${LIBDIR_SUFFIX}/$<TARGET_FILE_NAME:oclgrind-rt-icd>\n")
-endif()
-
-install(TARGETS
-  oclgrind-exe oclgrind-kernel
-  DESTINATION bin)
-install(TARGETS
-  oclgrind oclgrind-rt oclgrind-rt-icd
-  DESTINATION "lib${LIBDIR_SUFFIX}")
-install(FILES
-  ${CORE_HEADERS} ${OPENCL_C_H}
-  DESTINATION include/oclgrind)
-if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
-  install(FILES
-    src/CL/cl.h
-    src/CL/cl_d3d10.h
-    src/CL/cl_d3d11.h
-    src/CL/cl_dx9_media_sharing.h
-    src/CL/cl_egl.h
-    src/CL/cl_ext.h
-    src/CL/cl_gl.h
-    src/CL/cl_gl_ext.h
-    src/CL/cl_platform.h
-    src/CL/opencl.h
-    DESTINATION include/CL)
-endif()
-
-
-# Tests
-enable_testing()
-
-# Check for Python
-find_package(PythonInterp)
-if (PYTHONINTERP_FOUND)
-

=== tests/kernels/CMakeLists.txt ===
# CMakeLists.txt (Oclgrind)
# Copyright (c) 2013-2019, James Price and Simon McIntosh-Smith,
# University of Bristol. All rights reserved.
#
# This program is provided under a three-clause BSD license. For full
# license terms please see the LICENSE file distributed with this
# source code.

# Add kernel tests
file(READ TESTS KERNEL_TESTS)
string(REPLACE "\n" ";" KERNEL_TESTS ${KERNEL_TESTS})
foreach(test ${KERNEL_TESTS})
  add_test(
    NAME ${test}
    COMMAND
    ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tests/run_test.py
    $<TARGET_FILE:oclgrind-kernel>
    ${CMAKE_SOURCE_DIR}/tests/kernels/${test}.sim)
endforeach(${test})

# Set PCH directory
set_tests_properties(${KERNEL_TESTS} PROPERTIES
    ENVIRONMENT "OCLGRIND_PCH_DIR=${CMAKE_BINARY_DIR}/include/oclgrind")

# Expected failures
set_tests_properties(${XFAIL} PROPERTIES WILL_FAIL TRUE)

=== debian/changelog ===
oclgrind (21.10-4) unstable; urgency=medium

  * Fix building with -Werror=implicit-function-declaration.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 22 Mar 2024 16:26:14 +0100

oclgrind (21.10-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063225

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 01:42:15 +0000

oclgrind (21.10-3) unstable; urgency=medium

  * Switch to LLVM/Clang 14.  (Closes: #1017654)
  * Bump Standards-Version to 4.6.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 04 Jan 2023 14:16:19 +0100

oclgrind (21.10-2) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Switch from obsolete CL_EXT_* to CL_API_* macros.  (Closes: #1022306)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Oct 2022 23:18:45 +0200

oclgrind (21.10-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Switch to LLVM/Clang 13 (Closes: #974793)
  * Bump Standards-Version to 4.6.0. No changes needed.

 -- James Price <jamesprice.dev@gmail.com>  Sat, 23 Oct 2021 13:08:28 +0000

=== debian/control ===
--- 
+++ 
@@ -9,21 +9,27 @@
  debhelper-compat (= 13),
  dh-exec,
  cmake,
- llvm-9-dev,
- libclang-9-dev,
- clang-9,
+ llvm-14-dev,
+ libclang-14-dev,
+ libpolly-14-dev,
+ clang-14,
  libedit-dev,
  zlib1g-dev,
  libreadline-dev,
  opencl-c-headers,
  python3,
+# prevent accidental backports after the 64-bit time_t transition
+ dpkg-dev (>= 1.22.5),
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/jrprice/Oclgrind
 Vcs-Browser: https://salsa.debian.org/opencl-team/oclgrind
 Vcs-Git: https://salsa.debian.org/opencl-team/oclgrind.git
 
-Package: liboclgrind-19.10
+Package: liboclgrind-21.10t64
+Provides: ${t64:Provides}
+Replaces: liboclgrind-21.10
+Breaks: liboclgrind-21.10 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -42,7 +48,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, liboclgrind-19.10 (= ${binary:Version})
+Depends: ${misc:Depends}, liboclgrind-21.10t64 (= ${binary:Version})
 Description: development files for Oclgrind
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis
@@ -56,7 +62,7 @@
 Package: oclgrind
 Architecture: any
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-19.10
+Depends: ${shlibs:Depends}, ${misc:Depends}, liboclgrind-21.10t64
 Description: OpenCL device simulator
  Oclgrind is an extensible OpenCL device simulator that provides a
  plugin interface to facilitate the creation of tools to aid analysis

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%oclgrind-$1.tar.gz%" \
  https://github.com/jrprice/Oclgrind/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
